import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
/**
 * Constants for tab identification
 */
export declare const DEVELOPER_TAB_ID: string;
/**
 * DeveloperTab module
 * @private
 */
export declare class DeveloperTab {
    private container;
    private ribbonId;
    private formFieldsGroup;
    private controlGroup;
    private mappingGroup;
    private protectGroup;
    /**
     * Constructor for DeveloperTab class
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the DocumentEditor instance
     * @returns {DocumentEditor} The DocumentEditor instance
     */
    private readonly documentEditor;
    /**
     * Get the Developer tab configuration
     * @returns {RibbonTabModel} The Developer tab model
     */
    getDeveloperTab(): RibbonTabModel;
    /**
     * Update UI when selection changes in the document
     * @returns {void}
     * @private
     */
    updateDeveloperTabOnSelectionChange(): void;
    /**
     * Destroy the DeveloperTab instance
     * @returns {void}
     */
    destroy(): void;
}
