import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
/**
 * Constants for form fields group identification
 */
export declare const FORM_FIELDS_GROUP: string;
export declare const FORM_FIELDS_ID: string;
export declare const TEXT_FORM: string;
export declare const CHECKBOX: string;
export declare const DROPDOWN: string;
/**
 * FormFieldsGroup module
 */
export declare class FormFieldsGroup {
    private container;
    private ribbonId;
    private formFieldDropDown;
    /**
     * Constructor for FormFieldsGroup class
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the DocumentEditor instance
     * @returns {DocumentEditor} The DocumentEditor instance
     */
    private readonly documentEditor;
    /**
     * Get the FormFields group model
     * @returns {RibbonGroupModel} The FormFields group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Get the FormFields dropdown model
     * @returns {RibbonItemModel} The FormFields dropdown model
     */
    private getFormFieldsDropDownModel;
    /**
     * Handle form fields dropdown selection
     * @param {MenuEventArgs} args - Menu event arguments
     * @returns {void}
     */
    private onFormFieldsDropDownSelect;
    /**
     * Update UI based on current selection
     * @returns {void}
     */
    updateSelection(): void;
    /**
     * Destroy the FormFieldsGroup instance
     * @returns {void}
     */
    destroy(): void;
}
