import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
/**
 * Constants for mapping group identification
 */
export declare const MAPPING_GROUP: string;
export declare const XMLMAPPING_ID: string;
/**
 * MappingGroup module
 * @private
 */
export declare class MappingGroup {
    private container;
    private ribbonId;
    /**
     * Constructor for MappingGroup class
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the DocumentEditor instance
     * @returns {DocumentEditor} The DocumentEditor instance
     */
    private readonly documentEditor;
    /**
     * Get the Mapping group model
     * @returns {RibbonGroupModel} The Mapping group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Get the XML Mapping button model
     * @returns {RibbonItemModel} The XML Mapping button model
     */
    private getXmlMappingButtonModel;
    /**
     * Handle XML Mapping button click
     * @returns {void}
     */
    private onXmlMappingClick;
    /**
     * Update UI based on current selection
     * @returns {void}
     * @private
     */
    updateSelection(): void;
    /**
     * Destroy the MappingGroup instance
     * @returns {void}
     * @private
     */
    destroy(): void;
}
