import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const CLOSE_GROUP_ID: string;
export declare const CLOSE_BUTTON_ID: string;
/**
 * Represents the Close Group in Header & Footer tab
 * @private
 */
export declare class CloseGroup extends RibbonGroupBase {
    /**
     * Constructor for the CloseGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the ribbon group model for Close
     * @returns {RibbonGroupModel} The ribbon group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Closes the header and footer editor
     * @returns {void}
     */
    private closeHeaderFooter;
}
