import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
export declare const HEADER_FOOTER_TAB_ID: string;
/**
 * HeaderFooterTab module for document editor ribbon
 * @private
 */
export declare class HeaderFooterTab {
    private container;
    private localObj;
    private commonID;
    private pageNumbersGroup;
    private optionsGroup;
    private closeGroup;
    /**
     * Constructor for HeaderFooterTab
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the HeaderFooter tab model for ribbon
     * @returns {RibbonTabModel} The header footer tab model
     */
    getHeaderFooterTab(): RibbonTabModel;
    /**
     * Updates the checkbox states based on current document settings
     * @returns {void}
     */
    updateCheckboxStates(): void;
    /**
     * Clean up resources
     * @returns {void}
     */
    destroy(): void;
}
