import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const OPTIONS_GROUP_ID: string;
export declare const LINK_PREVIOUS_BUTTON_ID: string;
export declare const DIFFERENT_FIRST_BUTTON_ID: string;
export declare const DIFFERENT_ODD_EVEN_BUTTON_ID: string;
/**
 * Represents the Options Group in Header & Footer tab
 * @private
 */
export declare class OptionsGroup extends RibbonGroupBase {
    /**
     * Constructor for the OptionsGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the ribbon group model for Options
     * @returns {RibbonGroupModel} The ribbon group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Gets the current header/footer type
     * @returns {HeaderFooterType} The current header/footer type
     */
    private getCurrentHeaderFooterType;
    /**
     * Checks if the current header/footer is linked to previous
     * @returns {boolean} Whether the current header/footer is linked to previous
     */
    private isLinkToPreviousChecked;
    /**
     * Sets the link to previous value for the current header/footer
     * @param {string} headerFooterType - The header/footer type
     * @param {boolean} value - The value to set
     * @returns {void}
     */
    private setLinkToPreviousValue;
    /**
     * Updates the checkbox states based on current document state
     * @returns {void}
     */
    updateSelection(): void;
}
