import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
/**
 * Represents the Page Numbers Group in Header & Footer tab
 * @private
 */
export declare class PageNumbersGroup extends RibbonGroupBase {
    /**
     * Constructor for the PageNumbersGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the ribbon group model for Page Numbers
     * @returns {RibbonGroupModel} The ribbon group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Handler for page number button click - inserts current page number at cursor position
     * @returns {void}
     */
    private pageNumberHandler;
}
