import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonItemModel } from '@syncfusion/ej2-ribbon';
export declare const BULLET_LIST_ID: string;
/**
 * BulletsGroup class for handling bullet list operations in Document Editor ribbon
 * @private
 */
export declare class BulletsGroup {
    private appliedBulletStyle;
    private container;
    private ribbonId;
    private localObj;
    private eventHandlers;
    private bulletElements;
    /**
     * Constructor for BulletsGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    private readonly documentEditor;
    /**
     * Get the bullet list split button item configuration
     * @returns {RibbonItemModel} The ribbon item model for bullet list
     * @private
     */
    getBulletListItem(): RibbonItemModel;
    /**
     * Create bullet dropdown in ribbon
     * @returns {RibbonSplitButtonSettingsModel} SplitButtonModel configuration
     * @private
     */
    private createBulletSplitButton;
    private createBulletElements;
    private getBulletItems;
    private createBulletListTag;
    private updateSelectedBulletListType;
    private removeSelectedList;
    /**
     * Apply the last used bullet style
     * @returns {void}
     * @private
     */
    applyLastAppliedBullet(): void;
    /**
     * Handle bullet style selection from dropdown
     * @param {any} args - The event arguments
     * @returns {void}
     * @private
     */
    handleBulletSelection(args: any): void;
    private applyBulletStyle;
    private bulletNoneClick;
    private bulletDotClick;
    private bulletCircleClick;
    private bulletSquareClick;
    private bulletFlowerClick;
    private bulletArrowClick;
    private bulletTickClick;
    destroy(): void;
}
