import { RibbonGroupBase, IRibbonGroup } from '../ribbon-interfaces';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const CLIPBOARD_GROUP_ID: string;
export declare const CUT_ID: string;
export declare const COPY_ID: string;
export declare const PASTE_ID: string;
export declare const LOCAL_CLIPBOARD_ID: string;
/**
 * ClipboardGroup class for handling clipboard operations in Document Editor ribbon
 * @private
 */
export declare class ClipboardGroup extends RibbonGroupBase implements IRibbonGroup {
    /**
     * Get the Ribbon group model for Clipboard
     * @returns {RibbonGroupModel} - The ribbon group model for Clipboard
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Update clipboard buttons based on selection state
     * @returns {void}
     * @private
     */
    updateSelection(): void;
}
