import { RibbonGroupBase, IRibbonGroup } from '../ribbon-interfaces';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const FIND_GROUP_ID: string;
export declare const FIND_ID: string;
export declare const REPLACE_ID: string;
/**
 * FindGroup class for handling find and replace operations in Document Editor ribbon
 * @private
 */
export declare class FindGroup extends RibbonGroupBase implements IRibbonGroup {
    /**
     * Get the Ribbon group model for Find
     * @returns {RibbonGroupModel} - Ribbon group model for Find
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Update find buttons based on document state
     * @returns {void}
     * @private
     */
    updateSelection(): void;
}
