import { RibbonGroupBase, IRibbonGroup } from '../ribbon-interfaces';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const FONT_GROUP_ID: string;
export declare const FONT_FAMILY_ID: string;
export declare const FONT_SIZE_ID: string;
export declare const BOLD_ID: string;
export declare const ITALIC_ID: string;
export declare const UNDERLINE_ID: string;
export declare const STRIKETHROUGH_ID: string;
export declare const SUPERSCRIPT_ID: string;
export declare const SUBSCRIPT_ID: string;
export declare const FONT_COLOR_ID: string;
export declare const HIGHLIGHT_COLOR_ID: string;
export declare const CLEAR_FORMAT_ID: string;
export declare const GROW_FONT_ID: string;
export declare const SHRINK_FONT_ID: string;
export declare const CHANGE_CASE_ID: string;
/**
 * FontGroup class for handling font formatting operations in Document Editor ribbon
 * @private
 */
export declare class FontGroup extends RibbonGroupBase implements IRibbonGroup {
    private appliedHighlightColor;
    private highlightColorHandlers;
    /**
     * Get the Ribbon group model for Font formatting
     * @returns {RibbonGroupModel} - Ribbon group model for Font formatting
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Update font UI based on selection state
     * @returns {void}
     * @private
     */
    updateSelection(): void;
    private updateToggleButtonState;
    private getHighlightColorItems;
    private createHighlightColorSplitButton;
    private onHighlightColorClick;
    private closePopup;
    private applyHighlightColor;
    private getBackgroundColorFromHighlightColor;
    private boldAction;
    private italicAction;
    private underlineAction;
    private strikethroughAction;
    private superscriptAction;
    private subscriptAction;
    private changeCaseAction;
    private changeFontFamily;
    private changeFontSize;
    private changeFontColor;
    private clearFormatAction;
    private increaseFontSize;
    private decreaseFontSize;
    destroy(): void;
}
