import { RibbonGroupBase, IRibbonGroup } from '../ribbon-interfaces';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const HISTORY_GROUP_ID: string;
export declare const UNDO_ID: string;
export declare const REDO_ID: string;
/**
 * HistoryGroup class for handling history operations in Document Editor ribbon
 * @private
 */
export declare class HistoryGroup extends RibbonGroupBase implements IRibbonGroup {
    /**
     * Get the Ribbon group model for History
     * @returns {RibbonGroupModel} - The Ribbon group model for History
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Update undo/redo buttons based on history state
     * @returns {void}
     * @private
     */
    updateContentChanged(): void;
}
