import { RibbonGroupBase, IRibbonGroup } from '../ribbon-interfaces';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
import { DocumentEditorContainer } from '../../document-editor-container';
export declare const PARAGRAPH_GROUP_ID: string;
export declare const ALIGN_LEFT_ID: string;
export declare const ALIGN_CENTER_ID: string;
export declare const ALIGN_RIGHT_ID: string;
export declare const JUSTIFY_ID: string;
export declare const DECREASE_INDENT_ID: string;
export declare const INCREASE_INDENT_ID: string;
export declare const SHOW_HIDE_MARKS_ID: string;
export declare const BORDERS_ID: string;
/**
 * HomeParagraphGroup class for handling paragraph formatting operations in Document Editor ribbon
 * @private
 */
export declare class HomeParagraphGroup extends RibbonGroupBase implements IRibbonGroup {
    private bulletsGroup;
    private numberingGroup;
    private lineSpacingGroup;
    /**
     * Constructor for HomeParagraphGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the Ribbon group model for Paragraph formatting
     * @returns {RibbonGroupModel} - Ribbon group model for Paragraph formatting
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Update paragraph formatting buttons based on document state
     * @returns {void} - void
     * @private
     */
    updateSelection(): void;
    private updateToggleButtonState;
    private leftAlignmentAction;
    private centerAlignmentAction;
    private rightAlignmentAction;
    private justifyAction;
    private increaseIndentAction;
    private decreaseIndentAction;
    private toggleHiddenMarks;
    private bordersAction;
    /**
     * Clean up resources when group is destroyed
     * @returns {void}
     * @private
     */
    destroy(): void;
}
