import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
import { DocumentEditorContainer } from '../../document-editor-container';
export declare const HOME_TAB_ID: string;
export declare const HOME_TAB_TEXT: string;
/**
 * HomeTab class for Document Editor ribbon
 * Integrates all home tab component groups: History, Clipboard, Font, Paragraph, Find, and Styles
 * @private
 */
export declare class HomeTab {
    private historyGroup;
    private clipboardGroup;
    private fontGroup;
    private paragraphGroup;
    private findGroup;
    private stylesGroup;
    private container;
    constructor(container: DocumentEditorContainer);
    private initialize;
    /**
     * Get the Ribbon tab model for Home tab
     * @returns {RibbonTabModel} - The ribbon tab model for Home tab
     * @private
     */
    getHomeTab(): RibbonTabModel;
    /**
     * Update all groups based on document state
     * @returns {void}
     * @private
     */
    updateSelection(): void;
    updateContentChanged(): void;
    /**
     * Update the style gallery with the document's current styles
     * @returns {void}
     * @private
     */
    updateStyleGallery(): void;
    /**
     * Clean up resources when tab is destroyed
     * @returns {void}
     * @private
     */
    destroy(): void;
}
