import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonItemModel } from '@syncfusion/ej2-ribbon';
export declare const LINE_SPACING_ID: string;
/**
 * LineSpacingGroup class for handling line spacing operations in Document Editor ribbon
 * @private
 */
export declare class LineSpacingGroup {
    private appliedLineSpacing;
    private container;
    private ribbonId;
    private localObj;
    /**
     * Constructor for LineSpacingGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    private readonly documentEditor;
    /**
     * Get the line spacing dropdown item configuration
     * @returns {RibbonItemModel} - Line spacing dropdown item configuration
     * @private
     */
    getLineSpacingItem(): RibbonItemModel;
    /**
     * Set the line spacing based on current paragraph format
     * @returns {void}
     * @private
     */
    setLineSpacing(): void;
    private lineSpacingAction;
}
