import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonItemModel } from '@syncfusion/ej2-ribbon';
export declare const NUMBER_LIST_ID: string;
/**
 * NumberingGroup class for handling numbering list operations in Document Editor ribbon
 * @private
 */
export declare class NumberingGroup {
    private appliedNumberingStyle;
    private container;
    private ribbonId;
    private localObj;
    private numberListDropDiv;
    private numberListDropUlTag;
    private noneNumberTag;
    private numberList;
    private lowLetter;
    private upLetter;
    private lowRoman;
    private upRoman;
    private numberElements;
    private numberedAndBulletNoneClickHandler;
    private numberedNumberDotClickHandler;
    private numberedLowLetterClickHandler;
    private numberedUpLetterClickHandler;
    private numberedLowRomanClickHandler;
    private numberedUpRomanClickHandler;
    /**
     * Constructor for NumberingGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    private readonly documentEditor;
    /**
     * Get the numbering list split button item configuration
     * @returns {RibbonItemModel} - Numbering list split button item configuration
     * @private
     */
    getNumberingListItem(): RibbonItemModel;
    private createNumberingSplitButton;
    private getNumberingItems;
    private removeSelectedList;
    private updateSelectedNumberedListType;
    /**
     * Apply the last used numbering style
     * @returns {void}
     * @private
     */
    applyLastAppliedNumbering(): void;
    private handleNumberingSelection;
    private bulletNoneClick;
    private numberedNumberDotClick;
    private numberedLowLetterClick;
    private numberedUpLetterClick;
    private numberedLowRomanClick;
    private numberedUpRomanClick;
    private applyNumbering;
    destroy(): void;
}
