import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
export declare const IMAGE_LOCAL_ID: string;
/**
 * Illustrations group implementation for Insert tab
 * @private
 */
export declare class IllustrationsGroup extends RibbonGroupBase {
    private imagePicker;
    /**
     * Constructor for IllustrationsGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the Ribbon items for Illustrations group
     * @returns {RibbonGroupModel} - Ribbon group model for Illustrations group
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    private onImageDropDownSelect;
    private imageClickHandler;
    private onImageChange;
    private insertImage;
    /**
     * Clean up resources
     * @returns {void}
     */
    destroy(): void;
}
