import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
import { CommentsGroup } from './comments-group';
export declare const INSERT_TAB_ID: string;
/**
 * InsertTab class - Implements the Insert tab in DocumentEditor Ribbon using individual group classes
 * @private
 */
export declare class InsertTab {
    private container;
    private pagesGroup;
    private tablesGroup;
    private illustrationsGroup;
    private linksGroup;
    private tocGroup;
    private bookmarksGroup;
    /**
     * @private
     */
    commentsGroup: CommentsGroup;
    private headerFooterGroup;
    /**
     * Constructor for InsertTab class
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the Insert tab configuration
     * @returns {RibbonTabModel} - Insert tab configuration
     * @private
     */
    getInsertTab(): RibbonTabModel;
    /**
     * Update control states based on current selection
     * @returns {void}
     * @private
     */
    updateControlState(): void;
    /**
     * Clean up resources when tab is destroyed
     * @returns {void}
     * @private
     */
    destroy(): void;
}
