import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
import { DocumentEditorContainer } from '../../document-editor-container';
import { LayoutParagraphGroup } from './layout-paragraph-group';
export declare const LAYOUT_TAB_ID: string;
/**
 * Represents the Layout Tab in the Ribbon
 * @private
 */
export declare class LayoutTab {
    private container;
    private localObj;
    private pageSetupGroup;
    layoutParagraphGroup: LayoutParagraphGroup;
    /**
     * Constructor for the LayoutTab
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Creates the Layout tab for the ribbon
     * @returns {RibbonTabModel} - Ribbon tab model for Layout tab
     * @private
     */
    getLayoutTab(): RibbonTabModel;
    /**
     * Updates UI based on the current selection
     * @returns {void}
     * @private
     */
    updateControlState(): void;
    /**
     * Initializes event handlers
     * @returns {void}
     * @private
     */
    wireEvents(): void;
    /**
     * Disposes event handlers and resources
     * @returns {void}
     * @private
     */
    destroy(): void;
}
