import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const PAGE_SETUP_GROUP_ID: string;
export declare const MARGINS_BUTTON_ID: string;
export declare const MARGINS_DROPDOWN_ID: string;
export declare const ORIENTATION_DROPDOWN_ID: string;
export declare const SIZE_DROPDOWN_ID: string;
export declare const COLUMNS_DROPDOWN_ID: string;
export declare const BREAKS_DROPDOWN_ID: string;
/**
 * Represents the Page Setup Group in Layout tab
 * @private
 */
export declare class PageSetupGroup extends RibbonGroupBase {
    private commonId;
    /**
     * Constructor for the PageSetupGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the ribbon group model for Page Setup
     * @returns {RibbonGroupModel} - Ribbon group model for Page Setup
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    private getCurrentMarginType;
    private createMarginsDropdown;
    private onMarginsChange;
    private createOrientationDropdown;
    private onOrientationChange;
    private getCurrentPageSizeType;
    private createSizeDropdown;
    private onPageSizeChange;
    private getCurrentColumnType;
    private createColumnsDropdown;
    private onColumnsChange;
    private createBreaksDropdown;
    private onBreakInsert;
    /**
     * @returns {void}
     * @private
     */
    updateSelection(): void;
}
