import { DocumentEditorContainer } from '../../document-editor-container';
/**
 * Dialog class to manage alternative text input for images.
 * @returns {AltTextDialog} - Returns the AltTextDialog instance.
 * @private
 */
export declare class AltTextDialog {
    private container;
    private localObj;
    private target;
    private altTextArea;
    private textAreaElement;
    private readonly ALT_TEXT_INPUT_ID;
    /**
     * Constructor for AltTextDialog class
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    private initDialog;
    /**
     * Show the Alt Text Dialog
     * @returns {void}
     */
    show: () => void;
    private applyAltText;
    private hideDialog;
    private getCurrentAltText;
    /**
     * Clean up resources when destroyed
     * @returns {void}
     */
    destroy(): void;
}
