import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
import { RibbonGroupBase } from '../ribbon-interfaces';
/**
 * Alt Text Group implementation for Picture Format tab
 * @private
 */
export declare class AltTextGroup extends RibbonGroupBase {
    private altTextDialog;
    private readonly ALT_TEXT_BUTTON_ID;
    /**
     * Constructor for AltTextGroup class
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the Alt Text group configuration
     * @returns {RibbonGroupModel} - Alt Text group configuration
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Handle Alt Text button click
     * @returns {void}
     */
    private altTextButtonClick;
    /**
     * Clean up resources when destroyed
     * @returns {void}
     * @private
     */
    destroy(): void;
}
