import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
import { SizeGroup } from './size-group';
export declare const PICTURE_FORMAT_TAB_ID: string;
export declare const PICTURE_FORMAT_TAB_TEXT: string;
/**
 * Picture Format tab implementation
 */
export declare class PictureFormatTab {
    private container;
    private localObj;
    sizeGroup: SizeGroup;
    private altTextGroup;
    /**
     * Constructor for PictureFormatTab class
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the Picture Format tab configuration
     * @returns {RibbonTabModel} - Picture Format tab configuration
     * @private
     */
    getPictureFormatTab(): RibbonTabModel;
    /**
     * Updates the property controls with current image properties
     * @returns {void}
     * @private
     */
    updateImageProperties(): void;
    /**
     * Clean up resources when destroyed
     * @returns {void}
     * @private
     */
    destroy(): void;
}
