import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
export declare const INSERT_FOOTNOTE_BUTTON_ID: string;
export declare const INSERT_ENDNOTE_BUTTON_ID: string;
/**
 * Footnotes group implementation for Reference tab
 * @private
 */
export declare class FootnotesGroup extends RibbonGroupBase {
    /**
     * Constructor for FootnotesGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the Ribbon items for Footnotes group
     * @returns {RibbonGroupModel} - Ribbon group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Insert Footnote handler
     * @returns {void}
     */
    private insertFootnoteHandler;
    /**
     * Insert Endnote handler
     * @returns {void}
     */
    private insertEndnoteHandler;
    /**
     * Update UI based on selection state
     * @returns {void}
     * @private
     */
    updateSelection(): void;
}
