import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
export declare const REFERENCES_TAB_ID: string;
/**
 * Reference tab implementation
 * @private
 */
export declare class ReferenceTab {
    private container;
    private localObj;
    private tableOfContentsGroup;
    private footnotesGroup;
    /**
     * Constructor for ReferenceTab class
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the Reference tab configuration
     * @returns {RibbonTabModel} - Reference tab configuration
     * @private
     */
    getReferenceTab(): RibbonTabModel;
    /**
     * Update UI based on selection state
     * @returns {void}
     * @private
     */
    updateSelectionState(): void;
    /**
     * Clean up resources
     * @returns {void}
     * @private
     */
    destroy(): void;
}
