import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
/**
 * Table of Contents group implementation for Reference tab
 * @private
 */
export declare class TableOfContentsGroup extends RibbonGroupBase {
    private readonly TOC_BUTTON_ID;
    private readonly UPDATE_TOC_BUTTON_ID;
    /**
     * Constructor for TableOfContentsGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the Ribbon items for Table of Contents group
     * @returns {RibbonGroupModel} - Ribbon group model for Table of Contents group
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Insert Table of Contents
     * @returns {void}
     */
    private insertTableOfContents;
    /**
     * Update Table of Contents handler
     * @returns {void}
     */
    private updateTocHandler;
    /**
     * Update UI based on selection state
     * @returns {void}
     * @private
     */
    updateSelection(): void;
}
