import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const COMMENTS_GROUP: string;
export declare const NEW_COMMENT_ID: string;
export declare const PREVIOUS_COMMENT_ID: string;
export declare const NEXT_COMMENT_ID: string;
export declare const DELETE_COMMENT_ID: string;
export declare const DELETE_ALL_COMMENTS_ID: string;
export declare const SHOW_COMMENTS_ID: string;
/**
 * Represents the Comments Group in Review tab
 * @private
 */
export declare class CommentsGroup extends RibbonGroupBase {
    private showComments;
    /**
     * Constructor for the CommentsGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the ribbon group model for Comments
     * @returns {RibbonGroupModel} - Ribbon group model for Comments
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    private newCommentHandler;
    private previousCommentHandler;
    private nextCommentHandler;
    private deleteCommentDropdownHandler;
    private showCommentsHandler;
    /**
     * Update comment controls based on selection
     * @returns {void}
     * @private
     */
    updateSelection(): void;
    private updateDeleteMenuItemState;
    /**
     * @param {boolean} enable - Enable the comment
     * @returns {void}
     * @private
     */
    enableDisableCommentGroup(enable: boolean): void;
}
