import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
import { CommentsGroup } from './comments-group';
import { TrackingGroup } from './tracking-group';
/**
 * Constants for tab identification
 */
export declare const REVIEW_TAB_ID: string;
/**
 * ReviewTab module
 * @private
 */
export declare class ReviewTab {
    private container;
    private ribbonId;
    /**
     * @private
     */
    commentsGroup: CommentsGroup;
    /**
     * @private
     */
    trackingGroup: TrackingGroup;
    private protectGroup;
    /**
     * Constructor for ReviewTab class
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the Review tab configuration
     * @returns {RibbonTabModel} - Review tab configuration
     * @private
     */
    getReviewTab(): RibbonTabModel;
    /**
     * Update UI when selection changes in the document
     * @returns {void}
     * @private
     */
    updateReviewTabOnSelectionChange(): void;
    /**
     * Destroy the ReviewTab instance
     * @returns {void}
     * @private
     */
    destroy(): void;
}
