import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const TRACKING_GROUP: string;
export declare const TRACK_CHANGES_ID: string;
export declare const ACCEPT_ALL_ID: string;
export declare const REJECT_ALL_ID: string;
/**
 * Represents the Tracking Group in Review tab
 * @private
 */
export declare class TrackingGroup extends RibbonGroupBase {
    /**
     * Constructor for the TrackingGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the ribbon group model for Tracking
     * @returns {RibbonGroupModel} - Ribbon group model for Tracking
     * @private
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Handle click on track changes button
     * @returns {void}
     */
    private trackChangesHandler;
    /**
     * Handle click on accept all button
     * @returns {void}
     */
    private acceptAllHandler;
    /**
     * Handle click on reject all button
     * @returns {void}
     */
    private rejectAllHandler;
    /**
     * Update tracking controls based on document state
     * @returns {void}
     * @private
     */
    updateSelection(): void;
}
