import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
import { ShadingGroup } from './shading-group';
export declare const TABLE_DESIGN_TAB_ID: string;
/**
 * TableDesignTab class provides a ribbon tab for table design options
 * @private
 */
export declare class TableDesignTab {
    private container;
    private localObj;
    private bordersGroup;
    shadingGroup: ShadingGroup;
    /**
     * Constructor for the TableDesignTab class
     * @param {DocumentEditorContainer}  container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the Table Design tab configuration
     * @returns {RibbonTabModel} - RibbonTabModel for the Table Design tab
     * @private
     */
    getTableDesignTab(): RibbonTabModel;
    /**
     * Updates the state of table design controls based on the current selection
     * @returns {void}
     * @private
     */
    onSelectionChange(): void;
    /**
     * Clean up resources when destroyed
     * @returns {void}
     * @private
     */
    destroy(): void;
}
