import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const CELL_ALIGN_GROUP_ID: string;
export declare const ALIGN_TOP_BUTTON_ID: string;
export declare const ALIGN_CENTER_BUTTON_ID: string;
export declare const ALIGN_BOTTOM_BUTTON_ID: string;
/**
 * Represents the Cell Align Group in Table Layout tab
 * @private
 */
export declare class CellAlignGroup extends RibbonGroupBase {
    /**
     * Constructor for the CellAlignGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the ribbon group model for Cell Align
     * @returns {RibbonGroupModel} - Ribbon group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Applies top alignment to the selected cells
     * @returns {void}
     */
    private applyAlignTop;
    /**
     * Applies center alignment to the selected cells
     * @returns {void}
     */
    private applyAlignCenterHorizontal;
    /**
     * Applies bottom alignment to the selected cells
     * @returns {void}
     */
    private applyAlignBottom;
}
