import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const CELL_PROPERTIES_GROUP_ID: string;
export declare const MERGE_CELLS_BUTTON_ID: string;
/**
 * Represents the Cell Properties Group in Table Layout tab
 */
export declare class CellPropertiesGroup extends RibbonGroupBase {
    private commonID;
    /**
     * Constructor for the CellPropertiesGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the ribbon group model for Cell Properties
     * @returns {RibbonGroupModel} - Ribbon group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Gets the Merge Cells button model
     * @returns {RibbonItemModel} - Ribbon item model for Merge Cells button
     */
    private getMergeCellsButton;
    /**
     * Merges the selected cells
     * @returns { void }
     */
    private mergeSelectedCells;
    /**
     * Checks if cells can be merged
     * @returns {boolean} - True if cells can be merged, false otherwise
     */
    private canMergeCells;
    /**
     * Updates the merge cells button state based on selection
     * @returns {void}
     */
    updateSelection(): void;
    /**
     * Updates the merge cells button enabled/disabled state
     * @returns {void}
     */
    private updateMergeCellsButtonState;
}
