import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const TABLE_OPERATIONS_GROUP_ID: string;
export declare const SELECT_DROPDOWN_ID: string;
export declare const DELETE_DROPDOWN_ID: string;
export declare const INSERT_DROPDOWN_ID: string;
/**
 * Represents the Table Operations Group in Table Layout tab
 * @private
 */
export declare class TableOperationsGroup extends RibbonGroupBase {
    /**
     * Constructor for the TableOperationsGroup
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the ribbon group model for Table Operations
     * @returns {RibbonGroupModel} The ribbon group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Gets the Select dropdown model
     * @returns {RibbonItemModel} The ribbon item model
     */
    private getSelectDropDown;
    /**
     * Gets the Delete dropdown model
     * @returns {RibbonItemModel} The ribbon item model
     */
    private getDeleteDropDown;
    /**
     * Gets the Insert dropdown model
     * @returns {RibbonItemModel} The ribbon item model
     */
    private getInsertDropDown;
    private handleTableSelection;
    private handleTableDeletion;
    private handleTableInsertion;
}
