import { RibbonGroupBase } from '../ribbon-interfaces';
import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
export declare const TABLE_PROPERTIES_GROUP_ID: string;
export declare const TABLE_PROPERTIES_BUTTON_ID: string;
/**
 * Represents the Table Properties Group in Table Layout tab
 * @private
 */
export declare class TablePropertiesGroup extends RibbonGroupBase {
    /**
     * Constructor for the TablePropertiesGroup
     *
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the ribbon group model for Table Properties
     *
     * @returns {RibbonGroupModel} The ribbon group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Gets the Table Properties button model
     *
     * @returns {RibbonItemModel} The ribbon item model
     */
    private getTablePropertiesButton;
    /**
     * Opens the table properties dialog
     *
     * @returns {void}
     */
    private openTablePropertiesDialog;
}
