import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
export declare const TABLE_LAYOUT_TAB_ID: string;
/**
 * Represents the Table Layout Tab in the Ribbon
 * @private
 */
export declare class TableLayoutTab {
    private container;
    private localObj;
    private tableOperationsGroup;
    private cellPropertiesGroup;
    private cellAlignGroup;
    private tablePropertiesGroup;
    /**
     * Constructor for the TableLayoutTab
     *
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Gets the Table Layout Tab model
     *
     * @returns {RibbonTabModel} The ribbon tab model
     */
    getTableLayoutTab(): RibbonTabModel;
    /**
     * Updates UI based on table layout changes
     *
     * @returns {void}
     */
    onTableLayoutChange(): void;
    /**
     * Disposes event handlers
     *
     * @returns {void}
     */
    destroy(): void;
}
