import { DocumentEditorContainer } from '../../document-editor-container';
import { RibbonTabModel } from '@syncfusion/ej2-ribbon';
import { ZoomGroup } from './zoom-group';
export declare const VIEW_TAB_ID: string;
/**
 * View tab implementation
 * @private
 */
export declare class ViewTab {
    private container;
    private viewsGroup;
    /**
     * @private
     */
    zoomGroup: ZoomGroup;
    private showGroup;
    /**
     * Constructor for ViewTab class
     * @param {DocumentEditorContainer} container - DocumentEditorContainer instance
     */
    constructor(container: DocumentEditorContainer);
    /**
     * Get the View tab configuration
     * @returns {RibbonTabModel} The ribbon tab model
     */
    getViewTab(): RibbonTabModel;
    /**
     * Handle selection change to update ribbon controls state
     * @returns {void}
     */
    onSelectionChange(): void;
    /**
     * Clean up resources when tab is destroyed
     * This method properly disposes all group components and clears references
     * @returns {void}
     */
    destroy(): void;
}
