import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
import { RibbonGroupBase } from '../ribbon-interfaces';
/**
 * Views group implementation for View tab
 * @private
 */
export declare class ViewsGroup extends RibbonGroupBase {
    /**
     * Get the Ribbon items for Document Views group
     * @returns {RibbonGroupModel} The ribbon group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Handler for print layout button click
     * @returns {void}
     */
    private printLayoutHandler;
    /**
     * Handler for web layout button click
     * @returns {void}
     */
    private webLayoutHandler;
    /**
     * Handler for read only button click
     * @returns {void}
     */
    private readOnlyHandler;
    /**
     * Update selection to reflect current state
     * @returns {void}
     */
    updateSelection(): void;
    private toggleReadOnlyButton;
    private toggleLayoutButton;
}
