import { RibbonGroupModel } from '@syncfusion/ej2-ribbon';
import { RibbonGroupBase } from '../ribbon-interfaces';
/**
 * Zoom group implementation for View tab
 * @private
 */
export declare class ZoomGroup extends RibbonGroupBase {
    /**
     * Get the Ribbon items for Zoom group
     * @returns {RibbonGroupModel} The ribbon group model
     */
    getGroupModel(): RibbonGroupModel;
    /**
     * Handler for zoom in button click
     * @returns {void}
     */
    private zoomInHandler;
    /**
     * Handler for zoom out button click
     * @returns {void}
     */
    private zoomOutHandler;
    /**
     * Handler for full page button click
     * @returns {void}
     */
    private fitOnePageHandler;
    /**
     * Handler for 100% button click
     * @returns {void}
     */
    private hundredpercentHandler;
    /**
     * Handler for page width button click
     * @returns {void}
     */
    private pageWidthHandler;
    /**
     * Updates the enabled state of zoom buttons based on current zoom factor
     * @returns {void}
     */
    updateZoomButtonState(): void;
}
