/**
 * Supported ribbon tab types.
 */
export declare type RibbonTabType = 
/**
 * Home tab containing common formatting and editing options.
 */
'Home' | 
/**
 * Insert tab for adding content elements like tables, images, and links.
 */
'Insert' | 
/**
 * Layout tab for page layout settings and section formatting.
 */
'Layout' | 
/**
 * References tab for table of contents, and footnote/endnote reference elements.
 */
'References' | 
/**
 * Review tab for document review features like comments and track changes.
 */
'Review' | 
/**
 * View tab for document view options and display settings.
 */
'View' | 
/**
 * Developer tab for advanced features like form field and content control.
 */
'Developer' | 
/**
 * TableDesign tab for table styling and formatting options.
 */
'TableDesign' | 
/**
 * TableLayout tab for table structure modifications.
 */
'TableLayout' | 
/**
 * HeaderFooter tab for header and footer editing options.
 */
'HeaderFooter' | 
/**
 * PictureFormat tab for image editing and formatting options.
 */
'PictureFormat';
